
import java.awt.*;
import javax.swing.*;

import com.java4less.rbarcode.BarCodeEncoder;
import com.java4less.rdatamatrix.RDataMatrix;

import java.awt.event.*;
import java.awt.print.PageFormat;
import java.awt.print.Pageable;
import java.awt.print.Printable;
import java.awt.print.PrinterException;
import java.awt.print.PrinterJob;

public class DatamatrixDemo extends JFrame implements Pageable ,Printable  {
  JLabel jLabel15 = new JLabel();
  JPanel barcodePanel = new JPanel();
  JLabel jLabel10 = new JLabel();
  JComboBox comboEncoding = new JComboBox();
  JButton btnQuit = new JButton();
  JButton btnSave = new JButton();
  JButton btnPrint = new JButton();
  JButton btnApply = new JButton();
  JTextField txtCode = new JTextField();
  JTextField txtLeft = new JTextField();

  JLabel jLabel9 = new JLabel();
  JComboBox comboFormat = new JComboBox();
  JLabel jLabel5 = new JLabel();
  JLabel jLabel3 = new JLabel();
  JLabel jLabel1 = new JLabel();
  JTextField txtDotPixels = new JTextField();
  
  RDataMatrix bc= new RDataMatrix();
  PrinterJob printerJob;

  public DatamatrixDemo() {
	try {
	  jbInit();
	  userInit();
	}
	catch(Exception e) {
	  e.printStackTrace();
	}
  }
  public static void main(String[] args) {
	DatamatrixDemo datamatrixTest1 = new DatamatrixDemo();
	datamatrixTest1.show();
  }
  private void jbInit() throws Exception {
	txtDotPixels.setBounds(new Rectangle(359, 284, 85, 21));
	txtDotPixels.setText("4");
	jLabel1.setBounds(new Rectangle(12, 233, 53, 17));
	jLabel1.setText("Code");
	jLabel3.setBounds(new Rectangle(12, 288, 72, 17));
	jLabel3.setText("Format");
	jLabel5.setBounds(new Rectangle(277, 233, 48, 17));
	jLabel5.setText("Margin");
	comboFormat.setBounds(new Rectangle(90, 284, 171, 21));
	jLabel9.setBounds(new Rectangle(13, 259, 73, 17));
	jLabel9.setText("Encoding");
	txtLeft.setBounds(new Rectangle(359, 232, 85, 21));
	txtLeft.setText("20");
	txtCode.setBounds(new Rectangle(91, 232, 170, 21));
	txtCode.setText("12345678012");
	btnApply.setBounds(new Rectangle(50, 340, 79, 27));
	btnApply.addActionListener(new java.awt.event.ActionListener() {
	  public void actionPerformed(ActionEvent e) {
		btnApply_actionPerformed(e);
	  }
	});
	btnApply.setText("Apply");
	btnPrint.setBounds(new Rectangle(225, 340, 79, 27));
	btnPrint.addActionListener(new java.awt.event.ActionListener() {
	  public void actionPerformed(ActionEvent e) {
		btnPrint_actionPerformed(e);
	  }
	});
	btnPrint.setText("Print");
	btnSave.setBounds(new Rectangle(137, 340, 79, 27));
	btnSave.addActionListener(new java.awt.event.ActionListener() {
	  public void actionPerformed(ActionEvent e) {
		btnSave_actionPerformed(e);
	  }
	});
	btnSave.setText("Save");
	btnQuit.setBounds(new Rectangle(311, 340, 79, 27));
	btnQuit.addActionListener(new java.awt.event.ActionListener() {
	  public void actionPerformed(ActionEvent e) {
		btnQuit_actionPerformed(e);
	  }
	});
	btnQuit.setText("Quit");
	comboEncoding.setBounds(new Rectangle(90, 257, 171, 21));
	jLabel10.setText("Code");
	jLabel10.setBounds(new Rectangle(12, 233, 53, 17));
	barcodePanel.setBounds(new Rectangle(7, 4, 444, 222));
	barcodePanel.setBorder(BorderFactory.createEtchedBorder());
	barcodePanel.setBackground(Color.white);
	barcodePanel.setLayout(new java.awt.BorderLayout());
	jLabel15.setText("Dot Pixels");
	jLabel15.setBounds(new Rectangle(277, 289, 72, 17));
	this.getContentPane().setLayout(null);
	this.getContentPane().add(barcodePanel, null);
	this.getContentPane().add(txtCode, null);
	this.getContentPane().add(jLabel15, null);
	this.getContentPane().add(jLabel10, null);
	this.getContentPane().add(comboEncoding, null);
	this.getContentPane().add(txtLeft, null);
	this.getContentPane().add(comboFormat, null);
	this.getContentPane().add(jLabel5, null);
	this.getContentPane().add(jLabel3, null);
	this.getContentPane().add(jLabel1, null);
	this.getContentPane().add(txtDotPixels, null);
	this.getContentPane().add(jLabel9, null);
	this.getContentPane().add(btnQuit, null);
	this.getContentPane().add(btnSave, null);
	this.getContentPane().add(btnPrint, null);
	this.getContentPane().add(btnApply, null);
	
  }
  
  void userInit() {

	this.setBackground(java.awt.Color.lightGray);


	this.comboEncoding.addItem("ASCII");
	this.comboEncoding.addItem("C40");
	this.comboEncoding.addItem("TEXT");
	this.comboEncoding.addItem("BINARY");
	this.comboEncoding.addItem("NONE");
	this.comboEncoding.addItem("AUTO");
	this.comboEncoding.setSelectedIndex(5);
	
	this.comboFormat.addItem("AUTO");
	this.comboFormat.addItem("C10X10");
	this.comboFormat.addItem("C12X12");
	this.comboFormat.addItem("C14X14");
	this.comboFormat.addItem("C16X16");
	this.comboFormat.addItem("C18X18");
	this.comboFormat.addItem("C20X20");
	this.comboFormat.addItem("C22X22");
	this.comboFormat.addItem("C24X24");
	this.comboFormat.addItem("C26X26");
	this.comboFormat.addItem("C32X32");
	this.comboFormat.addItem("C36X36");
	this.comboFormat.addItem("C40X40");
	this.comboFormat.addItem("C44X44");
	this.comboFormat.addItem("C48X48");
	this.comboFormat.addItem("C52X52");
	this.comboFormat.addItem("C64X64");
	this.comboFormat.addItem("C72X72");
	this.comboFormat.addItem("C80X80");
	this.comboFormat.addItem("C88X88");
	this.comboFormat.addItem("C96X96");
	this.comboFormat.addItem("C104X104");
	this.comboFormat.addItem("C120X120");
	this.comboFormat.addItem("C132X132");
	this.comboFormat.addItem("C144X144");
	this.comboFormat.addItem("C8X18");
	this.comboFormat.addItem("C8X32");
	this.comboFormat.addItem("C12X26");
	this.comboFormat.addItem("C12X36");
	this.comboFormat.addItem("C16X36");
	this.comboFormat.addItem("C16X48");
	this.comboFormat.setSelectedIndex(0);
  
	this.setSize(465,420);
	this.setLocation(100,100);
	this.setTitle("Datamatrix Demo");


	applyData();

	barcodePanel.add(bc);

	}

	// load data into barcode object
	void applyData() {

	  bc.resolution=1;
	
	  try {
		  bc.margin=new Integer(this.txtLeft.getText()).intValue();
	
	  } catch (Exception ignore) {ignore.printStackTrace();}
  
      bc.encoding=this.comboEncoding.getSelectedIndex();
      bc.preferredFormat=this.comboFormat.getSelectedIndex()-1;
    
	  try {
	  bc.dotPixels=new Integer(this.txtDotPixels.getText()).intValue();
	  } catch (Exception ignore) {ignore.printStackTrace();}
	  
	  bc.code=txtCode.getText();
	  bc.reBuild=true;

	}

  void btnApply_actionPerformed(ActionEvent e) {
	applyData();
	this.paintAll(this.getGraphics());
	this.repaint();
	this.barcodePanel.paintAll(this.barcodePanel.getGraphics());
	this.barcodePanel.setVisible(false);
	this.barcodePanel.setVisible(true);
  }

  void btnSave_actionPerformed(ActionEvent e) {
	FileDialog f=new FileDialog(this,"Select JPG File",FileDialog.SAVE);

   f.show();

   if (f.getFile()!=null) {
	   String fi=f.getDirectory()+f.getFile();
	   System.out.println(fi);
	   BarCodeEncoder   be=  new BarCodeEncoder(bc,"JPG",fi);

	 }
  }

  void btnPrint_actionPerformed(ActionEvent e) {
	printerJob=PrinterJob.getPrinterJob();
	printerJob.setJobName("RBarcode");
	
	
	printerJob.setPageable(this);
	if (!printerJob.printDialog()) return;
	
	try {
		printerJob.print();
	} catch (PrinterException e1) {
		// TODO Auto-generated catch block
		e1.printStackTrace();
	}
  }

  void btnQuit_actionPerformed(ActionEvent e) {
	System.exit(0);
  }
  
  /* (non-Javadoc)
   * @see java.awt.print.Pageable#getNumberOfPages()
   */
  public int getNumberOfPages() {
	  return 1;
  }
  /* (non-Javadoc)
   * @see java.awt.print.Pageable#getPageFormat(int)
   */
  public PageFormat getPageFormat(int pageIndex) throws IndexOutOfBoundsException {
	  return printerJob.defaultPage();
  }
  /* (non-Javadoc)
   * @see java.awt.print.Pageable#getPrintable(int)
   */
  public Printable getPrintable(int pageIndex) throws IndexOutOfBoundsException {
	  return this;
  }
  /* (non-Javadoc)
   * @see java.awt.print.Printable#print(java.awt.Graphics, java.awt.print.PageFormat, int)
   */
  public int print(Graphics graphics, PageFormat pageFormat, int pageIndex) throws PrinterException {
	
	  int m=bc.margin;
	  bc.margin= (int) printerJob.defaultPage().getImageableWidth()/2;
	  

	  bc.paint(graphics);
	  bc.margin=m;
	  return 0;
  }

}
