
import java.awt.*;

import javax.swing.*;

import com.java4less.rbarcode.BarCode2D;
import com.java4less.rbarcode.BarCodeEncoder;

import java.awt.event.*;
import java.awt.print.PageFormat;
import java.awt.print.Pageable;
import java.awt.print.Printable;
import java.awt.print.PrinterException;
import java.awt.print.PrinterJob;

public class PDF417Demo extends JFrame implements Pageable ,Printable {
  JLabel jLabel15 = new JLabel();
  JLabel jLabel14 = new JLabel();
  JPanel barcodePanel = new JPanel();
  JLabel jLabel10 = new JLabel();
  JButton btnQuit = new JButton();
  JButton btnSave = new JButton();
  JButton btnPrint = new JButton();
  JButton btnApply = new JButton();
  JTextField txtCode = new JTextField();
  JTextField txtMargin = new JTextField();
  JTextField txtColumns = new JTextField();
  JTextField txtComboRows = new JTextField();
  JLabel jLabel9 = new JLabel();
  JLabel jLabel5 = new JLabel();
  JLabel jLabel3 = new JLabel();
  JLabel jLabel1 = new JLabel();
  JComboBox comboECLevel = new JComboBox();
  JComboBox comboCompaction = new JComboBox();
  JCheckBox chkTruncated = new JCheckBox();
  JLabel jLabel16 = new JLabel();
  JTextField txtBarHeight = new JTextField();
  JLabel jLabel17 = new JLabel();
  JTextField txtBarWidth = new JTextField();
  JPanel jPanel1 = new JPanel();
  JCheckBox chkMacro = new JCheckBox();
  JLabel jLabel18 = new JLabel();
  JTextField txtSegment = new JTextField();
  JLabel jLabel19 = new JLabel();
  JTextField txtSender = new JTextField();
  JLabel jLabel110 = new JLabel();
  JTextField txtAddresse = new JTextField();
  JTextField txtFilename = new JTextField();
  JTextField txtTimestamp = new JTextField();
  JLabel jLabel111 = new JLabel();
  JLabel jLabel112 = new JLabel();
  JLabel jLabel113 = new JLabel();
  JTextField txtFileId = new JTextField();
  JLabel jLabel114 = new JLabel();
  JTextField txtFileSize = new JTextField();
  JLabel jLabel115 = new JLabel();
  JTextField txtSegmentCount = new JTextField();
  
  BarCode2D bc=new BarCode2D();
  PrinterJob printerJob=null;

  public PDF417Demo() {
	try {
	  jbInit();
	  userInit();
	}
	catch(Exception e) {
	  e.printStackTrace();
	}
  }
  public static void main(String[] args) {
	PDF417Demo PDF417Test1 = new PDF417Demo();
	PDF417Test1.show();
  }
  private void jbInit() throws Exception {
	comboCompaction.setBounds(new Rectangle(86, 258, 171, 21));
	comboECLevel.setBounds(new Rectangle(86, 285, 171, 21));
	jLabel1.setText("Code");
	jLabel1.setBounds(new Rectangle(8, 234, 53, 17));
	jLabel3.setText("EC Level");
	jLabel3.setBounds(new Rectangle(8, 289, 72, 17));
	jLabel5.setText("Margin");
	jLabel5.setBounds(new Rectangle(273, 234, 48, 17));
	jLabel9.setText("Compaction");
	jLabel9.setBounds(new Rectangle(9, 260, 73, 17));
	txtComboRows.setText("4");
	txtComboRows.setBounds(new Rectangle(355, 285, 85, 21));
	txtColumns.setText("10");
	txtColumns.setBounds(new Rectangle(355, 258, 85, 21));
	txtMargin.setText("20");
	txtMargin.setBounds(new Rectangle(355, 233, 85, 21));
	txtCode.setText("12345678012");
	txtCode.setBounds(new Rectangle(87, 233, 170, 21));
	btnApply.setText("Apply");
	btnApply.setBounds(new Rectangle(48, 509, 79, 27));
	btnApply.addActionListener(new java.awt.event.ActionListener() {
	  public void actionPerformed(ActionEvent e) {
		btnApply_actionPerformed(e);
	  }
	});
	btnPrint.setText("Print");
	btnPrint.setBounds(new Rectangle(223, 509, 79, 27));
	btnPrint.addActionListener(new java.awt.event.ActionListener() {
	  public void actionPerformed(ActionEvent e) {
		try {
			btnPrint_actionPerformed(e);
		} catch (PrinterException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	  }
	});
	btnSave.setText("Save");
	btnSave.setBounds(new Rectangle(135, 509, 79, 27));
	btnSave.addActionListener(new java.awt.event.ActionListener() {
	  public void actionPerformed(ActionEvent e) {
		btnSave_actionPerformed(e);
	  }
	});
	btnQuit.setText("Quit");
	btnQuit.setBounds(new Rectangle(309, 509, 79, 27));
	btnQuit.addActionListener(new java.awt.event.ActionListener() {
	  public void actionPerformed(ActionEvent e) {
		btnQuit_actionPerformed(e);
	  }
	});
	jLabel10.setBounds(new Rectangle(8, 234, 53, 17));
	jLabel10.setText("Code");
	barcodePanel.setBackground(Color.white);
	barcodePanel.setBorder(BorderFactory.createEtchedBorder());
	barcodePanel.setBounds(new Rectangle(3, 3, 444, 222));
	barcodePanel.setLayout(new java.awt.BorderLayout());
	jLabel14.setBounds(new Rectangle(272, 263, 67, 17));
	jLabel14.setText("Columns");
	jLabel15.setBounds(new Rectangle(273, 290, 72, 17));
	jLabel15.setText("Rows");
	this.getContentPane().setLayout(null);
	chkTruncated.setText("Truncate / Compact");
	chkTruncated.setHorizontalTextPosition(SwingConstants.LEADING);
	chkTruncated.setBounds(new Rectangle(8, 314, 244, 25));
	jLabel16.setText("Bar height");
	jLabel16.setBounds(new Rectangle(11, 346, 72, 17));
	txtBarHeight.setBounds(new Rectangle(88, 342, 85, 21));
	txtBarHeight.setText("7");
	jLabel17.setText("Bar width");
	jLabel17.setBounds(new Rectangle(273, 346, 72, 17));
	txtBarWidth.setBounds(new Rectangle(355, 342, 85, 21));
	txtBarWidth.setText("1");
	jPanel1.setBorder(BorderFactory.createEtchedBorder());
	jPanel1.setBounds(new Rectangle(11, 372, 438, 131));
	jPanel1.setLayout(null);
	chkMacro.setBounds(new Rectangle(8, 8, 132, 25));
	chkMacro.setHorizontalTextPosition(SwingConstants.LEADING);
	chkMacro.setText("Macro PDF 417");
	jLabel18.setBounds(new Rectangle(8, 42, 72, 17));
	jLabel18.setText("Segment");
	txtSegment.setText("1");
	txtSegment.setBounds(new Rectangle(86, 38, 26, 21));
	jLabel19.setBounds(new Rectangle(8, 69, 72, 17));
	jLabel19.setText("Sender");
	txtSender.setBounds(new Rectangle(86, 65, 85, 21));
	jLabel110.setBounds(new Rectangle(8, 96, 71, 17));
	jLabel110.setToolTipText("");
	jLabel110.setText("Addresse");
	txtAddresse.setBounds(new Rectangle(86, 92, 85, 21));
	txtFilename.setBounds(new Rectangle(345, 35, 85, 21));
	txtTimestamp.setBounds(new Rectangle(346, 8, 85, 21));
	txtTimestamp.setText("123");
	jLabel111.setText("File name");
	jLabel111.setBounds(new Rectangle(246, 38, 72, 17));
	jLabel112.setText("Timestamp");
	jLabel112.setBounds(new Rectangle(246, 11, 72, 17));
	jLabel113.setText("File Id");
	jLabel113.setBounds(new Rectangle(246, 65, 72, 17));
	txtFileId.setBounds(new Rectangle(345, 60, 85, 21));
	txtFileId.setText("TEST");
	jLabel114.setBounds(new Rectangle(246, 89, 72, 17));
	jLabel114.setText("File size");
	txtFileSize.setText("0");
	txtFileSize.setBounds(new Rectangle(344, 86, 85, 21));
	jLabel115.setText("of");
	jLabel115.setBounds(new Rectangle(118, 41, 20, 17));
	txtSegmentCount.setBounds(new Rectangle(139, 39, 31, 21));
	txtSegmentCount.setText("2");
	this.getContentPane().add(jLabel15, null);
	this.getContentPane().add(jLabel10, null);
	this.getContentPane().add(txtCode, null);
	this.getContentPane().add(txtMargin, null);
	this.getContentPane().add(txtColumns, null);
	this.getContentPane().add(txtComboRows, null);
	this.getContentPane().add(jLabel9, null);
	this.getContentPane().add(jLabel5, null);
	this.getContentPane().add(jLabel3, null);
	this.getContentPane().add(jLabel1, null);
	this.getContentPane().add(comboECLevel, null);
	this.getContentPane().add(comboCompaction, null);
	this.getContentPane().add(btnQuit, null);
	this.getContentPane().add(btnSave, null);
	this.getContentPane().add(btnPrint, null);
	this.getContentPane().add(btnApply, null);
	this.getContentPane().add(jLabel14, null);
	this.getContentPane().add(txtBarHeight, null);
	this.getContentPane().add(txtBarWidth, null);
	this.getContentPane().add(jLabel17, null);
	this.getContentPane().add(jLabel16, null);
	this.getContentPane().add(chkTruncated, null);
	this.getContentPane().add(jPanel1, null);
	jPanel1.add(txtSegment, null);
	jPanel1.add(jLabel18, null);
	jPanel1.add(txtSender, null);
	jPanel1.add(jLabel19, null);
	jPanel1.add(txtAddresse, null);
	jPanel1.add(jLabel110, null);
	jPanel1.add(txtTimestamp, null);
	jPanel1.add(txtFilename, null);
	jPanel1.add(chkMacro, null);
	jPanel1.add(jLabel112, null);
	jPanel1.add(jLabel113, null);
	jPanel1.add(jLabel111, null);
	jPanel1.add(txtFileId, null);
	jPanel1.add(txtFileSize, null);
	jPanel1.add(jLabel114, null);
	jPanel1.add(txtSegmentCount, null);
	jPanel1.add(jLabel115, null);
	this.getContentPane().add(barcodePanel, null);
	

  }

  void userInit() {

  this.setBackground(java.awt.Color.lightGray);

  this.comboCompaction.addItem("Binary");
  this.comboCompaction.addItem("Text");
  this.comboCompaction.addItem("Numeric");
  this.comboCompaction.setSelectedIndex(0);
  
  this.comboECLevel.addItem("0");
  this.comboECLevel.addItem("1");
  this.comboECLevel.addItem("2");
  this.comboECLevel.addItem("3");
  this.comboECLevel.addItem("4");
  this.comboECLevel.addItem("5");
  this.comboECLevel.addItem("6");
  this.comboECLevel.addItem("7");
  this.comboECLevel.addItem("8");
  this.comboECLevel.setSelectedIndex(3);
    
  this.setSize(465,580);
  this.setLocation(100,100);
  this.setTitle("PDF417 Demo");


  applyData();

  barcodePanel.add(bc);

  }

  // load data into barcode object
  void applyData() {

	bc.resolution=1;
	bc.barType=BarCode2D.PDF417;
	bc.PDFCompact=this.chkTruncated.isSelected();
	
	try {
		bc.topMarginCM=new Integer(this.txtMargin.getText()).intValue();
		bc.leftMarginCM=new Integer(this.txtMargin.getText()).intValue();	
  	} catch (Exception ignore) {ignore.printStackTrace();}
  
    bc.PDFMode=this.comboCompaction.getSelectedIndex();
    bc.PDFECLevel=this.comboECLevel.getSelectedIndex();
    bc.PDFMacroAddresse=this.txtAddresse.getText();
	bc.PDFMacroSender=this.txtSender.getText();
	byte[] b=this.txtFileId.getText().getBytes();
	int[] fileId=new int[b.length];
	for (int i=0;i<fileId.length;i++) fileId[i]=b[i];
	bc.PDFMacroFileId=fileId;
	bc.PDFMacroFileName=this.txtFilename.getText();
	try {
	bc.PDFMacroFileSize=new Integer(this.txtFileSize.getText()).intValue();
	} catch (Exception ignore) {ignore.printStackTrace();}
	
	try {
		bc.PDFColumns=new Integer(this.txtColumns.getText()).intValue();
	} catch (Exception ignore) {ignore.printStackTrace();}
		
	bc.PDFMacroSegment=-1;	
	bc.PDFMacroSegmentCount=-1;
	
	
	if (this.chkMacro.isSelected()) {

		try {
			bc.PDFMacroSegment=new Integer(this.txtSegment.getText()).intValue()-1;
		} catch (Exception ignore) {ignore.printStackTrace();}
		
		try {
			bc.PDFMacroSegmentCount=new Integer(this.txtSegmentCount.getText()).intValue();
		} catch (Exception ignore) {ignore.printStackTrace();}
	}
			
	try {
		bc.PDFRows=new Integer(this.txtComboRows.getText()).intValue();
	} catch (Exception ignore) {ignore.printStackTrace();}
		
		
	try {
		bc.X=new Integer(this.txtBarWidth.getText()).intValue();
	} catch (Exception ignore) {ignore.printStackTrace();}
	
	try {
		bc.barHeightCM=new Integer(this.txtBarHeight.getText()).intValue();
	} catch (Exception ignore) {ignore.printStackTrace();}
		
	
	try {
		bc.PDFMacroTimeStamp=""+new Integer( this.txtTimestamp.getText() ).intValue();
	} catch (Exception ignore) {ignore.printStackTrace();}
	
		
	bc.PDFMacroLastSegment=(bc.PDFMacroSegmentCount==(bc.PDFMacroSegment+1));
	bc.PDFMaxRows=30;
	
	bc.code=txtCode.getText();
    

  }

  void btnApply_actionPerformed(ActionEvent e) {
	applyData();
	this.paintAll(this.getGraphics());
	this.repaint();
	this.barcodePanel.paintAll(this.barcodePanel.getGraphics());
	this.barcodePanel.setVisible(false);
	this.barcodePanel.setVisible(true);
  }

  void btnSave_actionPerformed(ActionEvent e) {
  	this.applyData();
	FileDialog f=new FileDialog(this,"Select JPG File",FileDialog.SAVE);

   f.show();

   if (f.getFile()!=null) {
	   String fi=f.getDirectory()+f.getFile();
	   System.out.println(fi);
	   BarCodeEncoder   be=  new BarCodeEncoder(bc,"JPG",fi);

	 }
  }

  void btnPrint_actionPerformed(ActionEvent e) throws PrinterException {


	printerJob=PrinterJob.getPrinterJob();
	printerJob.setJobName("RBarcode");
	
	printerJob.setPageable(this);
	if (!printerJob.printDialog()) return;
	
	printerJob.print();
	
	this.applyData();

  }

  void btnQuit_actionPerformed(ActionEvent e) {
	System.exit(0);
  }
/* (non-Javadoc)
 * @see java.awt.print.Pageable#getNumberOfPages()
 */
public int getNumberOfPages() {
	return 1;
}
/* (non-Javadoc)
 * @see java.awt.print.Pageable#getPageFormat(int)
 */
public PageFormat getPageFormat(int pageIndex) throws IndexOutOfBoundsException {
	return printerJob.defaultPage();
}
/* (non-Javadoc)
 * @see java.awt.print.Pageable#getPrintable(int)
 */
public Printable getPrintable(int pageIndex) throws IndexOutOfBoundsException {
	return this;
}
/* (non-Javadoc)
 * @see java.awt.print.Printable#print(java.awt.Graphics, java.awt.print.PageFormat, int)
 */
public int print(Graphics graphics, PageFormat pageFormat, int pageIndex) throws PrinterException {
	
	bc.leftMarginCM=printerJob.defaultPage().getImageableWidth()/2;
	bc.topMarginCM=printerJob.defaultPage().getImageableHeight()/3;

	bc.paint(graphics);
	return 0;
}
}
