
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import com.java4less.qrcode.*;

//  RAztec Code
//  Copyright (C)
//
//  Java4Less@Confluencia.net
//  All rights reserved
//
// Adquisition , use and distribution of this code is subject to restriction:
//  - You may modify the source code in order to adapt it to your needs.
//  - Redistribution of this ( or a modified version) source code is prohibited. You may only redistribute compiled versions.
//  - You may redistribute the compiled version as part of your application, not a new java component with the same purpose as this one.
//  - You may not remove this notice from the source code
//  - This notice disclaim all warranties of all material
//  - You may not copy and paste any code into external files.

public class QRCodeDemo extends JFrame {
  QRCode barcode = new QRCode();
  JTabbedPane jTabbedPane1 = new JTabbedPane();
  JPanel jPanel2 = new JPanel();
  JPanel jPanel3 = new JPanel();
  JButton btnApply = new JButton();
  JButton btnPrint = new JButton();
  JButton btnSave = new JButton();
  JButton btnExit = new JButton();
  JLabel jLabel1 = new JLabel();
  JTextField txtValue = new JTextField();
  JLabel jLabel2 = new JLabel();
  JLabel jLabel4 = new JLabel();
  JLabel jLabel5 = new JLabel();
  JLabel jLabel6 = new JLabel();
  JLabel jLabel8 = new JLabel();
  JCheckBox chkStructuredAppend = new JCheckBox();
  JLabel jLabel10 = new JLabel();
  JLabel jLabel11 = new JLabel();
  JTextField txtIndex = new JTextField();
  JTextField txtTotal = new JTextField();
  JComboBox cEncoding = new JComboBox();
  JComboBox cEC = new JComboBox();
  JComboBox cFormat = new JComboBox();
  JTextField txtMargin = new JTextField();
  JTextField txtModuleSize = new JTextField();
  JLabel jLabel13 = new JLabel();
  JComboBox cResolution = new JComboBox();
  JLabel jLabel9 = new JLabel();
  JLabel jLabel7 = new JLabel();
  JTextField txtAddIdentifier = new JTextField();
  JComboBox cFNC1 = new JComboBox();
  JCheckBox chkAutoConfigurate = new JCheckBox();

  public static void main(String[] args) {

    QRCodeDemo f=new QRCodeDemo();
    f.setSize(410,515);
    f.setLocation(100,100);
    f.show();
  }

  public QRCodeDemo() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    this.getContentPane().setLayout(null);
    barcode.setBounds(new Rectangle(3, 5, 395, 194));
    jTabbedPane1.setToolTipText("");
    jTabbedPane1.setBounds(new Rectangle(4, 206, 393, 228));
    btnApply.setText("Apply");
    btnApply.setBounds(new Rectangle(23, 446, 79, 27));
    btnApply.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnApply_actionPerformed(e);
      }
    });
    btnPrint.setText("Print");
    btnPrint.setBounds(new Rectangle(111, 446, 79, 27));
    btnPrint.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnPrint_actionPerformed(e);
      }
    });
    btnSave.setBounds(new Rectangle(200, 446, 79, 27));
    btnSave.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnSave_actionPerformed(e);
      }
    });
    btnSave.setText("Save");
    btnExit.setBounds(new Rectangle(291, 446, 79, 27));
    btnExit.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnExit_actionPerformed(e);
      }
    });
    btnExit.setText("Exit");
    jLabel1.setText("Value");
    jLabel1.setBounds(new Rectangle(6, 21, 48, 17));
    jPanel2.setLayout(null);
    txtValue.setText("0123456789");
    txtValue.setBounds(new Rectangle(55, 20, 316, 21));
    jLabel2.setText("Encoding");
    jLabel2.setBounds(new Rectangle(6, 52, 64, 17));
    jLabel4.setText("Version");
    jLabel4.setBounds(new Rectangle(6, 79, 62, 17));
    jLabel5.setText("Module size");
    jLabel5.setBounds(new Rectangle(6, 140, 76, 17));
    jLabel6.setText("Correction level");
    jLabel6.setBounds(new Rectangle(208, 50, 91, 17));
    jLabel8.setText("Margin");
    jLabel8.setBounds(new Rectangle(209, 146, 41, 17));
    jPanel3.setLayout(null);
    chkStructuredAppend.setText("Enable structured append");
    chkStructuredAppend.setBounds(new Rectangle(21, 15, 223, 25));
    jLabel10.setText("Index");
    jLabel10.setBounds(new Rectangle(17, 51, 48, 17));
    jLabel11.setText("Total");
    jLabel11.setBounds(new Rectangle(17, 76, 48, 17));
    txtIndex.setText("1");
    txtIndex.setBounds(new Rectangle(67, 48, 63, 21));
    txtTotal.setText("2");
    txtTotal.setBounds(new Rectangle(67, 75, 63, 21));
    cEncoding.setBounds(new Rectangle(75, 51, 126, 21));
    cEC.setBounds(new Rectangle(307, 51, 66, 21));
    cFormat.setBounds(new Rectangle(75, 81, 125, 21));
    txtMargin.setText("30");
    txtMargin.setBounds(new Rectangle(308, 144, 63, 21));
    txtModuleSize.setText("4");
    txtModuleSize.setBounds(new Rectangle(121, 138, 78, 21));
    jLabel13.setBounds(new Rectangle(8, 152, 119, 17));
    jLabel13.setText("Printer Resolution");
    cResolution.setBounds(new Rectangle(128, 151, 85, 21));
    cResolution.setBounds(new Rectangle(121, 168, 79, 21));
    jLabel13.setText("Printer Resolution");
    jLabel13.setBounds(new Rectangle(6, 169, 112, 17));
    this.setTitle("QRCode demo");
    jLabel9.setBounds(new Rectangle(208, 113, 92, 17));
    jLabel9.setText("App. Identifier");
    jLabel7.setBounds(new Rectangle(8, 109, 41, 17));
    jLabel7.setText("FNC1");
    txtAddIdentifier.setBounds(new Rectangle(307, 111, 63, 21));
    txtAddIdentifier.setText("0");
    cFNC1.setBounds(new Rectangle(76, 111, 125, 21));
    chkAutoConfigurate.setText("Autoconfigurate    ");
    chkAutoConfigurate.setHorizontalTextPosition(SwingConstants.LEADING);
    chkAutoConfigurate.setBounds(new Rectangle(210, 79, 149, 25));
    this.getContentPane().add(jTabbedPane1, null);
    jTabbedPane1.add(jPanel2, "QRCode");
    jPanel2.add(jLabel1, null);
    jPanel2.add(txtValue, null);
    jPanel2.add(jLabel2, null);
    jPanel2.add(cEncoding, null);
    jPanel2.add(cFormat, null);
    jPanel2.add(jLabel4, null);
    jPanel2.add(cEC, null);
    jPanel2.add(jLabel6, null);
    jPanel2.add(txtModuleSize, null);
    jPanel2.add(jLabel5, null);
    jPanel2.add(jLabel13, null);
    jPanel2.add(cResolution, null);
    jPanel2.add(cFNC1, null);
    jPanel2.add(jLabel9, null);
    jPanel2.add(txtAddIdentifier, null);
    jPanel2.add(jLabel7, null);
    jPanel2.add(chkAutoConfigurate, null);
    jPanel2.add(txtMargin, null);
    jPanel2.add(jLabel8, null);
    jTabbedPane1.add(jPanel3, "Structured Append");
    jPanel3.add(chkStructuredAppend, null);
    jPanel3.add(txtIndex, null);
    jPanel3.add(jLabel10, null);
    jPanel3.add(jLabel11, null);
    jPanel3.add(txtTotal, null);

    this.getContentPane().add(barcode, null);
    this.getContentPane().add(btnExit, null);
    this.getContentPane().add(btnSave, null);
    this.getContentPane().add(btnPrint, null);
    this.getContentPane().add(btnApply, null);

    this.cEncoding.addItem("AUTO");
    this.cEncoding.addItem("BYTE");
    this.cEncoding.addItem("NUMERIC");
    this.cEncoding.addItem("ALPHA");
    this.cEncoding.addItem("KANJI");

    this.cEC.addItem("L");
    this.cEC.addItem("M");
    this.cEC.addItem("Q");
    this.cEC.addItem("H");

    this.cResolution.addItem("72 dpi (default)");
    this.cResolution.addItem("300 dpi");
    this.cResolution.addItem("600 dpi");

this.cFormat.addItem("1");
this.cFormat.addItem("2");
this.cFormat.addItem("3");
this.cFormat.addItem("4");
this.cFormat.addItem("5");
this.cFormat.addItem("6");
this.cFormat.addItem("7");
this.cFormat.addItem("8");
this.cFormat.addItem("9");
this.cFormat.addItem("10");
this.cFormat.addItem("11");
this.cFormat.addItem("12");
this.cFormat.addItem("13");
this.cFormat.addItem("14");
this.cFormat.addItem("15");
this.cFormat.addItem("16");
this.cFormat.addItem("17");
this.cFormat.addItem("18");
this.cFormat.addItem("19");
this.cFormat.addItem("20");
this.cFormat.addItem("21");
this.cFormat.addItem("22");
this.cFormat.addItem("23");
this.cFormat.addItem("24");
this.cFormat.addItem("25");
this.cFormat.addItem("26");
this.cFormat.addItem("27");
this.cFormat.addItem("28");
this.cFormat.addItem("29");
this.cFormat.addItem("30");
this.cFormat.addItem("31");
this.cFormat.addItem("32");
this.cFormat.addItem("33");
this.cFormat.addItem("34");
this.cFormat.addItem("35");
this.cFormat.addItem("36");
this.cFormat.addItem("37");
this.cFormat.addItem("38");
this.cFormat.addItem("39");
this.cFormat.addItem("40");

    cFNC1.addItem("NO");
    cFNC1.addItem("FIRST");
    cFNC1.addItem("SECOND");

  }

  public void show() {
    super.show();
    btnApply_actionPerformed(null);
  }

  void btnApply_actionPerformed(ActionEvent e) {

  barcode.setProcessTilde(true);

  barcode.setCode(this.txtValue.getText());

  barcode.setEncoding(barcode.ENC_AUTO);
  if (this.cEncoding.getSelectedIndex()>=0)  {
       if (((String) this.cEncoding.getSelectedItem()).equals("BYTE"))  barcode.setEncoding(barcode.ENC_BYTE);
       if (((String) this.cEncoding.getSelectedItem()).equals("ALPHA"))  barcode.setEncoding(barcode.ENC_ALPHA);
       if (((String) this.cEncoding.getSelectedItem()).equals("NUMERIC"))  barcode.setEncoding(barcode.ENC_NUMERIC);
       if (((String) this.cEncoding.getSelectedItem()).equals("KANJI"))  barcode.setEncoding(barcode.ENC_KANJI);
  }

  barcode.setPreferredVersion(1);
  if (this.cFormat.getSelectedIndex()>=0)
        barcode.setPreferredVersion(Integer.parseInt((String) this.cFormat.getSelectedItem()));


  barcode.setFnc1Mode(QRCode.FNC1_MODE_NO);
  if (this.cFNC1.getSelectedIndex()>=0)  {
       if (((String) this.cFNC1.getSelectedItem()).equals("FIRST"))  barcode.setFnc1Mode(QRCode.FNC1_MODE_FIRST);
       if (((String) this.cFNC1.getSelectedItem()).equals("SECOND"))  barcode.setFnc1Mode(QRCode.FNC1_MODE_SECOND);
  }

  barcode.setErrorCorrectionLevel(QRCode.CORRECTION_LEVEL_L);
  if (this.cEC.getSelectedIndex()>=0)  {
       if (((String) this.cEC.getSelectedItem()).equals("H"))  barcode.setErrorCorrectionLevel(QRCode.CORRECTION_LEVEL_H);
       if (((String) this.cEC.getSelectedItem()).equals("Q"))  barcode.setErrorCorrectionLevel(QRCode.CORRECTION_LEVEL_Q);
       if (((String) this.cEC.getSelectedItem()).equals("M"))  barcode.setErrorCorrectionLevel(QRCode.CORRECTION_LEVEL_M);
  }

  barcode.setAutoConfigurate( this.chkAutoConfigurate.isSelected() );


  if (this.chkStructuredAppend.isSelected()) barcode.setStructuredAppend(true);
  else barcode.setStructuredAppend(false);

try {

    barcode.setModuleSize(Integer.parseInt(this.txtModuleSize.getText()));
    barcode.setMargin(Integer.parseInt(this.txtMargin.getText()));
    barcode.setApplicationIndicator((byte) Integer.parseInt(this.txtAddIdentifier.getText()));
    barcode.setStructuredAppendCounter(Integer.parseInt(this.txtTotal.getText()));
    barcode.setStructuredAppendIndex(Integer.parseInt(this.txtIndex.getText()));


    }
    catch (Exception ex) {}

    this.paintAll(this.getGraphics());
    this.repaint();
    barcode.setRedraw(true);
    barcode.paint(barcode.getGraphics());



  }

  void btnPrint_actionPerformed(ActionEvent e) {

   // set printer resolution
    java.awt.PageAttributes pa= new PageAttributes();

    if (this.cResolution.getSelectedIndex()==1) pa.setPrinterResolution(300);
    if (this.cResolution.getSelectedIndex()==2) pa.setPrinterResolution(600);
    //pa.setPrinterResolution(barcode.getResolution());

    // get printer job
    java.awt.PrintJob pj=Toolkit.getDefaultToolkit().getPrintJob(this,"J4L-QRCode",null,pa);

    barcode.setRedraw(true);

    java.awt.image.BufferedImage im=new java.awt.image.BufferedImage(barcode.getWidth(),barcode.getHeight(),java.awt.image.BufferedImage.TYPE_INT_RGB);
    Graphics g2=im.createGraphics();
    barcode.paint(g2);

    //    print barcode
    Graphics g= pj.getGraphics();

     g.drawImage(im,pj.getPageDimension().width/2,pj.getPageDimension().height/3,null);
    // end job
    pj.end();

  }

  void btnSave_actionPerformed(ActionEvent e) {

    FileDialog f=new FileDialog(this,"Select JPG File",FileDialog.SAVE);

     f.show();

     if (f.getFile()!=null) {
         barcode.setSize(barcode.getPreferredSize());
         String fi=f.getDirectory()+f.getFile();
         if (!fi.toUpperCase().endsWith("JPG")) fi=fi+".jpg";
         System.out.println(fi);
         ImageEncoder   be=  new ImageEncoder(barcode,"JPEG",fi);

         javax.swing.JOptionPane.showMessageDialog(this,"The JPEG file has been saved. We recommend you to use GIF or PNG formats for scanning purposes. See Documentation.");
       }
  }

  void btnExit_actionPerformed(ActionEvent e) {
      System.exit(0);
  }

}
